/// <reference types="koa-compose" />
/// <reference types="ws" />
/// <reference types="node" />
import * as compose from 'koa-compose';
import * as http from 'http';
import * as WebSocket from 'ws';
import { EventHandler, SocketContext } from './index';
export default class Socket {
    middleware: compose.ComposedMiddleware<SocketContext> | null;
    ws: WebSocket;
    request: http.ServerRequest;
    constructor(ws: WebSocket, request: http.ServerRequest, listeners: Map<string, EventHandler[]>, middleware: compose.ComposedMiddleware<SocketContext> | null);
    update(listeners: Map<string, EventHandler[]>, middleware: compose.ComposedMiddleware<SocketContext> | null): void;
    /**
     * Adds a specific event and callback to this socket
     */
    on(event: string, handler: EventHandler): void;
    invokeHandler(handler: EventHandler, ctx: SocketContext, message: any): void;
}
